%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2013 koeart, john, ben                                         %
%                                                                          %
% This program is free software: you can redistribute it and/or modify it  %
% under the terms of the GNU General Public License as published by the    %
% Free Software Foundation, either version 3 of the License, or (at your   %
% option) any later version.                                               %
%                                                                          %
% This program is distributed in the hope that it will be useful, but      %
% WITHOUT ANY WARRANTY; without even the implied warranty of               %
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        %
% General Public License for more details.                                 %
%                                                                          %
% You should have received a copy of the GNU General Public License along  %
% with this program.  If not, see <http://www.gnu.org/licenses/>.          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\ProvidesClass{datenschleuder}[%
	2013/07/19 v0.1 Datenschleuder
]
\LoadClass[%
	10pt,
	pdftex,
	a5paper,
	BCOR=1cm,
	twoside,
	twocolumn,
	DIV=15,
	%headheight=36px
]{scrartcl}

\RequirePackage{xkeyval}
\newcommand{\@volume}{}
\DeclareOptionX{volume}{\renewcommand{\@volume}{#1}}%
\newcommand{\@year}{}
\DeclareOptionX{year}{\renewcommand{\@year}{#1}}%
\ProcessOptionsX

\RequirePackage{ifluatex}
\ifluatex
	\RequirePackage{luatextra}
	\RequirePackage{lineno}
	\RequirePackage[EU2]{fontenc}
	\RequirePackage{fontspec}
	\setmainfont[Mapping=tex-text,Numbers={OldStyle}]{Linux Libertine O}
	\setsansfont[Mapping=tex-text,Numbers={OldStyle}]{Linux Biolinum O}
	\setmonofont[Mapping=tex-text]{Courier Prime}
\fi


\RequirePackage{scrpage2}
\pagestyle{scrheadings}
\setheadsepline{0.5pt}

\ifoot[]{Datenschleuder. \@volume / \@year}
\ofoot[]{\thepage}
\setfootsepline{0.5pt}

%FIXME: use abstract environment in prior of nasty DSabstract command
\renewenvironment{abstract}{%
	\begin{center}
		\bfseries
}{%
	\end{center}
}
\newcommand{\@DSabstract}{}
\newcommand{\DSabstract}[1]{\renewcommand{\@DSabstract}{#1}}


\renewcommand{\maketitle}{%
	\twocolumn[
		\textsf{\Huge\@title}

		\begin{center}%
			\textsf{von \@author}%FIXME: implement mail and array of authors
		\end{center}

		{\bfseries\@DSabstract}
		\vspace*{3mm}
	]

	\normalsize
}

\define@key{DSarticleKeys}{title}{\renewcommand{\@title}{#1}}%
\define@key{DSarticleKeys}{author}{\author{#1}}
\define@key{DSarticleKeys}{DSabstract}{\renewcommand{\@DSabstract}{#1}}

\newenvironment{DSarticle}[1][]{%
	\setkeys{DSarticleKeys}{#1}%
	\maketitle
}{}

